<?php

namespace Drupal\qtools_cache_profiler\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Session\AccountProxyInterface;
use Drupal\qtools_common\Utility\QToolsDebug;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\Request;

/**
 * Controller for render cache preview report.
 */
class RenderCachePreviewController extends ControllerBase {

  /**
   * Returns page content.
   */
  public function previewRenderCache(Request $request): array {

    $build['title'] = [
      '#type' => 'inline_template',
      '#template' => '<h4>{{ title }}</h4>',
      '#context' => [
        'title' => $this->t('Render cache'),
      ],
    ];

    $build['cookie_hint'] = [
      '#type' => 'inline_template',
      '#template' => '{{ text }} <b>{{ command }}</b>',
      '#context' => [
        'text' => $this->t('To preview render cache info on the page set cookie '),
        'command' => $this->t('qtools_cache_profiler_active=1'),
      ],
    ];

    return $build;
  }

}
